//Phoenix 6 License information:
//Not Commercial use defined by QPL Open Source License.
//Contact PhoenixFund for Commercial License. Derivative works must also be QPL.
//Unless alternatively licensed by copyright holder, no commercial derivative works may exist.
//Traders Dynamic Index Heavily borrowed from Dean Malone
//Traders Dynamic Index, Copyright  2006, Dean Malone
//+------------------------------------------------------------------+
#property copyright "Copyright PhoenixFund under QPL License. www.bestforextools.com/pf/"

#define Buy +1    //used for Signals
#define Sell -1
#define None 0
#define Failed -1 //used for Order Modify
/*#property indicator_buffers 6
#property indicator_color1 Black
#property indicator_color2 MediumBlue
#property indicator_color3 Yellow
#property indicator_color4 MediumBlue
#property indicator_color5 Green
#property indicator_color6 Red
#property indicator_separate_window */

//************* User Variables ******************//
//System Changes
extern bool       EnableLogging              = false;
extern bool       EnableSignalDebug          = false;
extern string     EAComment="";
//Profit management
bool              staticTPOn                 = true;
int               AcceptSlip                 = 3;
extern int        staticTP                   = 48;
//extern double adjustDynTP= 0.8;

//Loss management
bool              staticSLOn                 = true;
extern int        staticSL                   = 90;

//Trade management
extern int        maxtrades                  = 1;
extern int        SignalsConsec              = 20;   
extern bool       SignalQuitOnBlank          = false; 
extern string     U_Trade_CURRENCY           = "USDCHF";
extern string     U_Trade_PERIOD             = "M15";

extern string     C_Function_Y               = "====== U_DecreaseFactor decreases lotsize in a losing streak =====";
extern bool       U_MoneyManage              = true; //Money management for lot sizing
extern double     U_Lots                     = 1;        //Money management will override setting
extern double     U_MaxRisk                  = 0.05;     
extern int        U_DecreaseFactor           = 0;    //6 digit number, 2 digits per subsequent loss 805010= 80% 50% 10%
//Daraknor Add 5.7.1 contrib Dmitry_CH, modified version of min/max settings with new style.
extern double	  U_MinLot		     = 0.01;	 //Set to be micro safe by default, maybe this should change
extern double	  U_MaxLot		     = 99.0;	 //Set to previous max value by default

//ExitSignal
extern bool ExitManagedOn = false;
extern bool ExitParaTSOn = false;
extern int staticTS =20;
extern bool MoveTPonTS=1; //increase Trailing stop by this value in pips each time TS is adjusted. Allows good trades to rise higher
extern int U_DelayTS=0;
extern int U_BreakEvenSL=0;
extern int ExitRecrossMax=0;      //Not multitrade safe :/ needs an array of ticket numbers?
int recrosscount, bcRecross;

extern string     C_Function_X               = "====== Exit Grace Functionality ======";
extern int        U_PeriodGraceHours         = 0;       //Setting of 0 disables, 24 = 24 hours Daraknor 5.6.6
extern int        U_PeriodForceHours         = 0;       //Setting of 0 disables, 48 = 48 hours Darankor 5.6.6
extern int	  U_GraceTrailingStop	     = 10;	//Trailing stop in pips to use during Grace Exit: should be small

//Lot management
extern bool splitTradeOn = false;
extern int splitTrade1 = 50;
extern int splitTrade2 = 60;
extern int splitTrade3 = 70;
extern int splitTrade4 = 80;
extern int splitTrade5 = 90;
extern int splitTrade6 = 100;

extern string     C_SignalA                  = "====== Signals Enabled ============================";
extern int        signalsRequired            = 4;     //Needs to be <= # of Entry Signals
extern bool       EntrySignal1On             = false;
extern bool       EntrySignal2On             = false;
extern bool       EntrySignal3On             = false;
extern bool       EntrySignal4On             = false;
extern bool       EntrySignal5On             = true;

extern bool       ConfirmSignal1On           = false;
extern bool       EntryFilter1On             = false;
extern bool       EntryFilter2On             = false;
extern bool       EntryFilter3On             = false;
extern bool       EntryFilter4On             = false;

extern string     C_Signal1                  = "====== Signal 1 ===================================";
extern int RSI_Period = 13;         //8-25
extern int RSI_Price = 0;           //0-6

extern string     C_Signal2                  = "====== Signal 2 ==================================";
extern int Volatility_Band = 34;    //20-40

extern string     C_Signal3                  = "====== Signal 3 ==================================";
extern int RSI_Price_Line = 2;      
extern int RSI_Price_Type = 0;      //0-3
extern int Trade_Signal_Line = 7;   
extern int Trade_Signal_Type = 0;   //0-3
double RSIBuf[],UpZone[],MdZone[],DnZone[],MaBuf[],MbBuf[];

extern string     C_Signal4               = "====== Signal 4 (EASY) =================================";
extern int        P_PACPer                = 5;
extern int        P_PACShift              = 10;


extern string     C_Signal5               = "====== Signal 5 (EASY) =================================";
extern int        P_RSI_High              = 50;
extern int        P_RSI_Low               = 50;
extern int        P_RSIArrPer             = 13;

extern string     C_Confirm1               = "====== Signal 5 (EASY) =================================";
extern double     U_ConfirmLotPerc        = 1.00;

extern string     C_Filter1                  = "====== Filter 1: Divergence ======================";
extern int        P_Fast_Period              = 25;
int        P_Fast_Price               = PRICE_OPEN;
extern int        P_Slow_Period              = 37;
int        P_Slow_Price               = PRICE_OPEN;
extern double     P_DVBuySell                = 0.00031;
extern double     P_DVStayOut                = 0.044;

extern string     C_Filter2                  = "====== Filter 2: Time ===========================";
extern int        U_AllFrom1                  = 0;    //Defaults will trader 24 hours Mon-Thu
extern int        U_AllUntil1                 = 24;   
extern int        U_AllFrom2                  = 0;
extern int        U_AllUntil2                 = 24;
extern int        U_SunFrom                   = 0;    //Sunday trading is disabled
extern int        U_SunUntil                  = 0;
extern int        U_FriFrom                   = 0;    //Friday trading ends early
extern int        U_FriUntil                  = 13;
int currentHour; //One global variable saves thousands of CPU cycles.
extern string     C_Filter3_4                = "====== Filter 3&4 Trend =========================";
extern int        TrendPeriod                 = 30;
extern int        TrendShift                  = 5;
extern double     P_TrendStrength             = 30;  //Difference in pips between price and MA.
//******************* Global Variables ***************//
int MagicNumSet1 = 101010;
int maxMagic = 0; //Set size of magic numbers used
bool W_GreenLight=true;
string W_Trade_PERIOD;
int nDaysSince1970 = 0;
int LogHandle = -1;
int BuySignal, SellSignal;
int W_DVBuySell, W_DVStayOut;
double W_RSI1, W_RSI2, W_RSI3;   //3 globals saves 6 indicator calls.
int W_RSIBar, W_ES4_SRBar;
double W_ES4_SR[4];
  
void init()
{ //Startup Functions, only called once.
  if((Symbol() != U_Trade_CURRENCY) && (Symbol() != U_Trade_CURRENCY+"m")){
    Alert("These settings are designed for "+U_Trade_CURRENCY+
      " only! Change chart or update U_Trade_CURRENCY");
    W_GreenLight=false;
  }
  if(U_MaxLot >MarketInfo(Symbol(),MODE_MAXLOT)) U_MaxLot=MarketInfo(Symbol(),MODE_MAXLOT);
  if(U_MinLot >MarketInfo(Symbol(),MODE_MINLOT)) U_MaxLot=MarketInfo(Symbol(),MODE_MINLOT);
  switch(Period())
  {
    case 1:
      W_Trade_PERIOD="M1";
      break;
    case 5:
      W_Trade_PERIOD="M5";
      break;
    case 15:
      W_Trade_PERIOD="M15";
      break;  
    case 30:
      W_Trade_PERIOD="M30";
      break;
    case 60:
      W_Trade_PERIOD="H1";
      break;      
    case 240:
      W_Trade_PERIOD="H4";
      break;
    case 1440:
      W_Trade_PERIOD="D1";
      break;
    case 10080:
      W_Trade_PERIOD="W1";
      break;
    case 43200:
      W_Trade_PERIOD="M1";
      break;
    default:
      Alert("Your timeframe "+Period()+" was not detected.");
      W_Trade_PERIOD="";
   }
  if(U_Trade_PERIOD != W_Trade_PERIOD){
    Alert("These settings are designed for "+U_Trade_PERIOD+
      " only! Change chart or update U_Trade_PERIOD");
    W_GreenLight=false;
  }   
  //Initial Settings:
  W_DVBuySell=MathCeil(P_DVBuySell/Point);
  W_DVStayOut=MathCeil(P_DVStayOut/Point);
  //TODO starting balance for complex money management.

   IndicatorShortName("Traders Dynamic Index");
   SetIndexBuffer(0,RSIBuf);
   SetIndexBuffer(1,UpZone); //VB High
   SetIndexBuffer(2,MdZone); //Market Base Line
   SetIndexBuffer(3,DnZone); //VB Low
   SetIndexBuffer(4,MaBuf);  // RSI Price Line
   SetIndexBuffer(5,MbBuf); //Trade Signal Line
   
   SetIndexStyle(0,DRAW_NONE); 
   SetIndexStyle(1,DRAW_LINE); 
   SetIndexStyle(2,DRAW_LINE,0,2);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE,0,2);
   SetIndexStyle(5,DRAW_LINE,0,2);
   
   SetIndexLabel(0,NULL); 
   SetIndexLabel(1,"VB High"); 
   SetIndexLabel(2,"Market Base Line"); 
   SetIndexLabel(3,"VB Low"); 
   SetIndexLabel(4,"RSI Price Line");
   SetIndexLabel(5,"Trade Signal Line");
 
   SetLevelValue(0,50);
   SetLevelValue(1,68);
   SetLevelValue(2,32);
   SetLevelStyle(STYLE_DOT,1,DimGray);  
}
void start()
{
  if(W_GreenLight!= true) return(0);
  OpenLog("MyLog.txt");
  //*************** Detect open trades *********************//
  for (int cticket = 0; cticket < OrdersTotal(); cticket++) { //Detect open trades
   if (OrderSelect(cticket, SELECT_BY_POS) == false) continue;
   if (OrderSymbol() != Symbol()) continue;
   if (OrderMagicNumber() >= MagicNumSet1 && OrderMagicNumber() <= MagicNumSet1 + maxMagic) 
   {
     if (OrderType() == 0) CheckExit(OrderTicket()); //Buy
     else if (OrderType() == 1) CheckExit(OrderTicket()); //Sell
   }
  }
  if (maxtrades > OrdersTotal())EnterNewTrade();
  LogFlush();
} //End Start() 


//********************* Check for New Trade *******************//
void EnterNewTrade()
{ //Check singals and conditions to enter new trade
int signal;
bool disableBuy=false;
bool disableSell=false;
/* 
if (EntryFilter1On) //Changed filters to quit ASAP.
  if (EntryFilter1()) return; //{disableBuy=true; disableSell=true;}
if (EntryFilter2On)
  if (EntryFilter2()) return; //{disableBuy=true; disableSell=true;}
if (EntryFilter3On)
  if (EntryFilter3()) {disableBuy=true; BuySignal=0;}
if (EntryFilter4On)
  if (EntryFilter4()) {disableSell=true; SellSignal=0;}
//if (EntryFilter5On)
//  if (EntryFilter5()) return; //{disableBuy=true; disableSell=true;}
*/
   EntrySetup(); //Prepare the arrays if necessary.  
   //TODO Probably exit points
   //TODO use ExitSignal1
   //TODO enter new trade once per bar inside EntrySetup?
   if (EntrySignal1On)
   {
      signal += EntrySignal1();
      Debug("Signal1 sum: "+signal);
   }
   if (EntrySignal2On)
   {
      signal += EntrySignal2();
      Debug("Signal2 sum: "+signal);
   }
/*   if (EntrySignal3On)
   {
      signal += EntrySignal3();
      Debug("Signal3 sum: "+signal);
   }   */
   if (EntrySignal4On)
   {
      signal += EntrySignal4();
      Debug("Signal4 sum: "+signal);
   }
   if (EntrySignal5On)
   {
      signal += EntrySignal5();
      Debug("Signal5 sum: "+signal);
   }   
if(!disableBuy)
  if(signal >= signalsRequired) 
   { //Check for Buy
    BuySignal++;
    SellSignal=0;
   }    //Conserve Execution, Check for Sell

if(!disableSell) 
  if(signal <= (-1)*signalsRequired)
   {
    BuySignal=0;
    SellSignal++;        
   } 

if(SignalQuitOnBlank)
   if(  (signal <= (-1)*signalsRequired) && (signal >= signalsRequired))
      {//If neither buy nor sell signal is received
        BuySignal=0;
        SellSignal=0; 
      }

Log("signal#:"+signal+" SignalsConsec:" +SignalsConsec+" BuySignal:" +BuySignal+" SellSignal:"+ SellSignal);
if(SignalsConsec<=BuySignal) 
{ 
  OrderNewBuy(GetLotSize()*EntryConfirmation1(OP_BUY)); 
  BuySignal=0;  
  recrosscount=0; //reset recross count for new trade.
  if(EntrySignal3()==Buy) OrderNewBuy(GetLotSize());
} 
else if(SignalsConsec<=SellSignal) 
{ 
  OrderNewSell(GetLotSize()*EntryConfirmation1(OP_SELL)); 
  SellSignal=0;
  recrosscount=0; //reset recross count for new trade.
  if(EntrySignal3()==Sell) OrderNewSell(GetLotSize());
}
}
//*************** Exit strategies **************************//
void CheckExit(int myticket)
{
  if(U_PeriodGraceHours !=0 ||U_PeriodForceHours !=0) X_ForceClose_or_GraceModify(myticket);
  if(ExitRecrossMax!=0)
  {
    double price;
      if (OrderType() == OP_BUY) price=Bid;
       if (OrderType() == OP_SELL)price=Ask;
       if(Bars>bcRecross)
       { //Bar hasn't been counted yet
         if(OrderOpenPrice()>price-1 && OrderOpenPrice()<price+1)
         {
            recrosscount++;
            bcRecross=Bars;
            if (recrosscount>=ExitRecrossMax)
               if(!OrderClose(myticket,OrderLots(),price,AcceptSlip,Red)) LogError();
         }
       }

   }
//TODO StealthExit
   if (ExitManagedOn) {
      if (ExitParaTSOn) 
      {
         double paraSAR=iSAR(NULL,0,0.02,0.2,1);
         trailingStop(myticket,paraSAR,0);
      } else trailingStop(myticket,staticTS,U_DelayTS);
   }
   if(U_BreakEvenSL!=0)
   {
      if(Bid-OrderOpenPrice()>Point*U_BreakEvenSL && (OrderStopLoss()< OrderOpenPrice()))
      ModifySL(OrderOpenPrice(),myticket);  
   }
}
void X_ForceClose_or_GraceModify(int ticket)
   {  //Add/Modify Daraknor 5.6.6 contrib by HerbertH in original Phoenix 2007 thread.

   int PeriodForce=U_PeriodForceHours*3600;
   int PeriodGrace=U_PeriodGraceHours*3600;
   double newSL=0;  //Daraknor Add 5.7.1 Need to make sure new SL is better than the old one. Temp Variable.
   OrderSelect(ticket, SELECT_BY_POS, MODE_TRADES); //TODO verify this line is redundant and unnecessary
   if (PeriodForce!=0)
            {
            if((OrderOpenTime() + PeriodForce) < Time[0])
               {
               if(OrderType() == OP_BUY) OrderClose(OrderTicket(),OrderLots(),Bid,3,Red); //3 points slippage allowed?
               if(OrderType() == OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);
               }
            }
         if(PeriodGrace!=0)
            {
               if(OrderOpenTime() + PeriodGrace < Time[0])
                  {
		                trailingStop(ticket, U_GraceTrailingStop,-1000);  // -1000=No profit delay on TS with PeriodGrace
		              }
            }
         
      
   }
void trailingStop (int ticket, int tsvalue, int delayts)
{
    double slvalue;
    Debug("EXIT:TS ticket:"+ticket+" tsvalue:"+tsvalue+" delayts:"+delayts);
    if (OrderType() == OP_BUY)
    {
      slvalue=Bid-(Point*tsvalue);
      if (OrderStopLoss() < slvalue && OrderOpenPrice()+Point*delayts<Bid+tsvalue*Point)
      {
        //Debug("OrderSL:" +OrderStopLoss()+ " slvalue:"+ slvalue);
        if (!ModifySL(slvalue,ticket)) LogError();
      }
    } else {
      if (OrderType() == OP_SELL)
      {
        slvalue=Ask+(Point*tsvalue);
        if (OrderStopLoss() > slvalue && OrderOpenPrice()-Point*delayts>Ask-tsvalue*Point)
        {
          //Debug("OrderSL:" +OrderStopLoss()+ " slvalue:"+ slvalue);
          ModifySL(slvalue,ticket);
        }
      }
    }
}
bool ModifySL(double sl, int ticket)
{
    int MoveTP;
    if (OrderType() == OP_SELL) MoveTP=MoveTPonTS*(-1);
    else MoveTP=MoveTPonTS;
    Debug("MODIFY Ticket:"+ticket+" OpenPrice:"+OrderOpenPrice()+" SL:"+sl+" TP:"+(OrderTakeProfit()+MoveTP*Point));
    if(OrderModify(ticket,OrderOpenPrice(),sl,OrderTakeProfit()+MoveTP*Point,0,Red)!=(-1)) LogError();
}
//*********************Trade Management *****************//
double GetLotSize()
{ 
    if(!U_MoneyManage) return(U_Lots);
    double lot          =U_Lots;
    int    orders       =HistoryTotal();
    int    i            =orders-1;
    int    trades       =0;
    int    wins         =0;
    int    losses       =0;
    double lotStep=MarketInfo(Symbol(),MODE_LOTSTEP);
 //   Log("ALERT lotstep from broker is "+lotStep);
    if(lotStep==0) lotStep =.0001; //TODO Safety feature... need to debug this better.
    lot=AccountFreeMargin()*U_MaxRisk/1000.0;
    if(U_DecreaseFactor>256)
    { //need to check for a real value
       while (trades< 3 && i > 0) 
       {
          if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) 
          { 
            Log("Error in history!"); 
            break; 
          }
          if(OrderSymbol()==Symbol() && OrderType()<=OP_SELL) 
          {
              trades++;
              if(OrderProfit()<0) losses++;
              if(OrderProfit()>0) wins++;
          }  
          i--;
       }
       if (U_DecreaseFactor > 999999)
       {
           Log("U_DecreaseFactor too large.  Changed to 802000");
           U_DecreaseFactor = 802000;
       }
       int Loss1_Percentage =  U_DecreaseFactor * 0.0001;
       int Loss2_Percentage = (U_DecreaseFactor - 10000 * Loss1_Percentage) * 0.01;
       int Loss3_Percentage = (U_DecreaseFactor - 10000 * Loss1_Percentage
                                                -   100 * Loss2_Percentage);
                                                
       Log("Breakit "+Loss1_Percentage+" "+Loss2_Percentage+" "+Loss3_Percentage) ;                                               
//     if (losses==0){ lot=lot*100             *0.01;   }  //This line is just documentation
       if (losses==1){ lot=lot*Loss1_Percentage*0.01;   }
       if (losses==2){ lot=lot*Loss2_Percentage*0.01;   }
       if (losses>=3){ lot=lot*Loss3_Percentage*0.01;   }
       Log("  losses "+losses+"  lot "+lot);
      }
    if(lot<U_MinLot) { lot=U_MinLot; Log("lots switched to min "+lot); }
    if(lot>U_MaxLot) { lot=U_MaxLot; Log("lots switched to max "+lot); }
    lot/=lotStep;
    lot = NormalizeDouble(lot,0);
    lot *= lotStep;
    return(lot);
}
//TODO we need to collect data on "trades that win most often" based on signals.
double EntryConfirmation1(int direction)
{ //Gann Style Support and Resist Lines.
   if(!ConfirmSignal1On) return (1.0);
   double value=1;
   if(W_ES4_SRBar>iBars(Symbol(),PERIOD_H4))
   {
      W_ES4_SRBar=iBars(Symbol(),PERIOD_H4);
      W_ES4_SR[4]=iHigh(Symbol(),PERIOD_H4,1);
      W_ES4_SR[0]=iLow(Symbol(),PERIOD_H4,1);
      if(W_ES4_SR[4]-W_ES4_SR[0]<(staticTP+staticSL)*Point)
      {
         W_ES4_SR[4]=iHigh(Symbol(),PERIOD_D1,1);
         W_ES4_SR[0]=iLow(Symbol(),PERIOD_D1,1);
      }
      W_ES4_SR[3]=(W_ES4_SR[0]+W_ES4_SR[4])*0.75;
      W_ES4_SR[2]=(W_ES4_SR[0]+W_ES4_SR[4])*0.5;
      W_ES4_SR[1]=(W_ES4_SR[0]+W_ES4_SR[4])*0.25;
   }
   int next=ArrayBsearch(W_ES4_SR,Bid);
   if(direction==OP_SELL) 
   {
      if(Bid+staticSL*Point>W_ES4_SR[next]) value=U_ConfirmLotPerc;
   }
   if(direction==OP_BUY) 
   {
      if(next !=0)//safe array
      { 
         if(Bid-staticSL*Point<W_ES4_SR[next-1]) value=U_ConfirmLotPerc; 
      }
      else value=1;
   }
   return (value);  
}

/*double EntryConfirmation2()
{ //TODO Speed Angle Check
return(1.0);
}
*/

void OrderNewBuy(double lots)
{ //Trade TP+SL Signals
  double calcTP, calcSL;
  if (staticTPOn) calcTP = staticTP;
  else calcTP = staticTP; //TODO add dynamic tp/sl
  if (staticSLOn) calcSL = staticSL;
  else calcSL = staticSL; //TODO add dynamic tp/sl
  if (calcTP == 0 || calcSL == 0)
  {
    Log("Missing TP or SL. TP:" + calcTP + " SL:" + calcSL);
  } else {
    if (splitTradeOn) splitTrades(calcTP, calcSL, lots, 0);
    else fireTrade(calcTP, calcSL, lots, 0);
  }
}
void OrderNewSell(double lots)
{ //Trade TP+SL Signals
double calcTP, calcSL;
  if (staticTPOn) calcTP = staticTP;
  else calcTP = staticTP; //todo add dynamic tp/sl
  if (staticSLOn) calcSL = staticSL;
  else calcSL = staticSL; //todo add dynamic tp/sl
  if (calcTP == 0 || calcSL == 0)
  {
    Log("Missing TP or SL. TP:" + calcTP + " SL:" + calcSL);
  } else {
    if (splitTradeOn) splitTrades(calcTP, calcSL, lots, 1);
    else fireTrade(calcTP, calcSL, lots, 1);
  } 
}

void splitTrades(int calcTP, int calcSL, double lots, int order)
{
int lotStep=MarketInfo(Symbol(),MODE_LOTSTEP);
int splitcount = 0; //so much easier to do this pedantically than recursively.
if (splitTrade1 != 0) splitcount++;
if (splitTrade2 != 0) splitcount++;
if (splitTrade3 != 0) splitcount++;
if (splitTrade4 != 0) splitcount++;
if (splitTrade5 != 0) splitcount++;
if (splitTrade6 != 0) splitcount++;
double splitlots = NormalizeDouble(lots / (splitcount*lotStep), 0)* lotStep;
fireTrade(calcTP * splitTrade1 / 100, calcSL, splitlots, order, 1);
fireTrade(calcTP * splitTrade2 / 100, calcSL, splitlots, order, 2);
fireTrade(calcTP * splitTrade3 / 100, calcSL, splitlots, order, 3);
fireTrade(calcTP * splitTrade4 / 100, calcSL, splitlots, order, 4);
fireTrade(calcTP * splitTrade5 / 100, calcSL, splitlots, order, 5);
fireTrade(calcTP * splitTrade6 / 100, calcSL, splitlots, order, 6);
}

int fireTrade(int TP, int SL, double lot, int order, int incMagic = 0)
{ //Execute Trades
  double price;
  color arrow;
  int ticket;
  string tradecomment= EAComment + " P6a4";
  if (incMagic==0) tradecomment="Primary Order"; 
  else tradecomment="Order is "+incMagic;
  if (order %2==0) 
  { //if number is even
    price = Ask;
    arrow = Blue;
  }
  if (order %2==1) 
  { //if number is odd
    price = Bid;
    SL = -SL;
    TP = -TP;
    arrow = Red;
  }
//ticket = OrderSend(Symbol(), order, lot, price, AcceptSlip,price-SL*Point,price+TP*Point, "",MagicNumSet1 + incMagic, 0, arrow);
//ticket = OrderSend(Symbol(),OP_BUY,1,Ask,3,Ask-25*Point,Ask+25*Point,"My order #2",16384,0,Green);
//buy works ticket = OrderSend(Symbol(),order,1,price,AcceptSlip,price-25*Point,price+25*Point,"",MagicNumSet1 + incMagic, 0, arrow);
ticket = OrderSend(Symbol(),order,lot,price,AcceptSlip,price-SL*Point,price+TP*Point,tradecomment,MagicNumSet1 + incMagic, 0, arrow);
  if (ticket != Failed){
    Log("Success:"+ticket+" "+Symbol()+" order:"+order+" lot:"+lot+" price:"+price+" SL:"+(price-SL*Point)+" TP:"+(price+TP*Point));
    return (ticket); //TODO use ticket number somehow
  } else {
    int error=GetLastError();
    Log("Error:"+error+" "+Symbol()+" order:"+order+" lot:"+lot+" price:"+price+" SL:"+(price-SL*Point)+" TP:"+(price+TP*Point));
    if(error==129 || error==130 || error==135 || error==138)
    { //Handle a few errors we know about, usually price movement. TODO make this configurable.
      RefreshRates();
      ticket=OrderSend(Symbol(), order, lot, price, AcceptSlip,
            price - SL * Point,price + TP * Point, tradecomment,
            MagicNumSet1 + incMagic,0, arrow);
      if (ticket != Failed) return (ticket); //TODO use ticket number somehow
      else Log("Error: Order send failed twice. Quitting."+ GetLastError());
    } else if(error==4 || error==136 || error==137 ||error==146)
    { //Busy Errors, sleep a little then retry
      Sleep(2000);
      RefreshRates();
      ticket=OrderSend(Symbol(), order, lot, price, AcceptSlip,
            price - SL * Point,price + TP * Point, tradecomment,
            MagicNumSet1 + incMagic,0, arrow);
      if (ticket != Failed) return (ticket); //TODO use ticket number somehow
      else Log("Error: Order send failed twice. Quitting."+ GetLastError());      
    }
  }
}

//********************** SIGNALS *********************//
int BarEASY;

void EntrySetup()
{
   double MA,RSI[];
   ArrayResize(RSI,Volatility_Band); //VB=34
   int counted_bars=IndicatorCounted();
   if(BarEASY>Bars)
   {
      BarEASY=Bars;
      int limit = Bars-counted_bars-1;
      for(int i=limit; i>=0; i--)
      {
         RSIBuf[i] = (iRSI(NULL,0,RSI_Period,RSI_Price,i)); //Period=13 Price=0
         MA = 0;
         for(int x=i; x<i+Volatility_Band; x++) 
         {
            RSI[x-i] = RSIBuf[x];
            MA += RSIBuf[x]/Volatility_Band;  //VB=34
         }
         UpZone[i] = (MA + (1.6185 * StDev(RSI,Volatility_Band)));
         DnZone[i] = (MA - (1.6185 * StDev(RSI,Volatility_Band)));  
         MdZone[i] = ((UpZone[i] + DnZone[i])/2);
      }
   }
   for (i=limit-1;i>=0;i--)  
   {
      MaBuf[i] = (iMAOnArray(RSIBuf,0,RSI_Price_Line,0,RSI_Price_Type,i)); // PriceLine=2 PriceType=0
      MbBuf[i] = (iMAOnArray(RSIBuf,0,Trade_Signal_Line,0,Trade_Signal_Type,i));  //Line=7 Type=0 
   }   
}

bool ExitSignal1()
{  //RSI and TSL crossing means Exit
   bool SellNow;
   if( (RSIBuf[1]<MbBuf[1]) && (RSIBuf[0]>MbBuf[0]) ) SellNow=true;
   if( (RSIBuf[1]>MbBuf[1]) && (RSIBuf[0]<MbBuf[0]) ) SellNow=true;
}

int EntrySignal1()
{ //RSI > TSL means Buy RSI < TSL means Sell
   int value=0;
   if(RSIBuf[0]>MbBuf[0]) value=Buy;
   if(RSIBuf[0]<MbBuf[0]) value=Sell;
   return (value);
}

int EntrySignal2()
{//RSI > MBL means Buy   RSI < MBL means Sell
 //TODO Market reversals when MBL hits 32 or 68 = entry signal? reversal for Phoenix?
   int value=0;
   if(RSIBuf[0]>MdZone[0]) value=Buy;
   if(RSIBuf[0]<MdZone[0]) value=Sell;
   return (value);
}

int EntrySignal3()
{ //RSI > VB means add a second Buy  RSI < VB means add a second Sell
   int value=0;
   if(RSIBuf[0]>UpZone[0]) value=Buy;
   if(RSIBuf[0]<DnZone[0]) value=Sell;
   return (value);   
}
int EntrySignal4()
{ //part of EASY
    int value=0;
    double HighPAC1 = iMA(NULL,0,P_PACPer,P_PACShift,MODE_SMMA,PRICE_HIGH,0);
    double LowPAC1  = iMA(NULL,0,P_PACPer,P_PACShift,MODE_SMMA,PRICE_LOW,0);
    double haClose1 = (Open[0] + High[0] + Low[0] + Close[0])*(0.25);
    if(haClose1 > HighPAC1) value=Buy;
    if(haClose1 < LowPAC1) value=Sell;
    Debug("Signal4 PAC High:"+HighPAC1+" LowPAC1:"+LowPAC1+" haClose1:"+haClose1);
    return(value);
}

int EntrySignal5()
{ //part of EASY
    int value=0;
    double RSILine = iRSI(NULL,0,P_RSIArrPer,PRICE_CLOSE,0); //Period=13 Price=0
    if(RSILine > P_RSI_High)  value=Buy;
    if(RSILine < P_RSI_Low ) value=Sell;
}
//*********** SIGNAL FUNCTIONS**************//
double StDev(double& Data[], int Per)
{return(MathSqrt(Variance(Data,Per)));
}
double Variance(double& Data[], int Per)
{double sum, ssum;
  for (int i=0; i<Per; i++)
  {sum += Data[i];
   ssum += MathPow(Data[i],2);
  }
  return((ssum*Per - sum*sum)/(Per*(Per-1)));
}

bool EntryFilter1(){
   bool value=true;
   return (value);  
}
bool EntryFilter2()
{ //Time Expiry
   bool value=true;
   return (value);
}
bool EntryFilter3()
{  //if BUY Signal, check buy trend. True = trade.
  bool value=true;
  return(value);
}
bool EntryFilter4()
{  //if SELL Signal, check sell trend
  //Currently assuming that rising and falling trends have similar properties.
  bool value=true;
  return(value);
}


//*********************** LOGGING **************************//
void OpenLog(string strName)
{
if (!EnableLogging && !EnableSignalDebug)
return;
if (TimeCurrent() / (60 * 60 * 24) > nDaysSince1970 || LogHandle <= 0) 
{ //Pick a new filename and open it.
  if (LogHandle > 0) FileClose(LogHandle);
  string strMonthPad = "";
  string strDayPad = "";
  if (Month() < 10) strMonthPad = "0";
  if (Day() < 10) strDayPad = "0";
  string strFilename =StringConcatenate(strName, "_", Year(), 
      strMonthPad, Month(),strDayPad, Day(), "_log.txt");
  LogHandle =FileOpen(strFilename, FILE_CSV | FILE_READ | FILE_WRITE);
  nDaysSince1970 = TimeCurrent() / (60 * 60 * 24);
}
FileFlush(LogHandle);
FileSeek(LogHandle, 0, SEEK_END);
}

void Log(string msg)
{
   if (!EnableLogging) return;
   if (LogHandle <= 0) return;
   msg = TimeToStr(TimeCurrent(),
      TIME_DATE | TIME_MINUTES | TIME_SECONDS) + " " + msg;
   FileWrite(LogHandle, msg);
}
void Debug(string msg)
{ //Signal Debugging, rarely called
   if (!EnableSignalDebug) return;
   if (LogHandle <= 0) return;
   msg = TimeToStr(TimeCurrent(),
      TIME_DATE | TIME_MINUTES | TIME_SECONDS) + " " + msg;
   FileWrite(LogHandle, msg);
}

void LogFlush()
{
if (!EnableLogging)return;
FileFlush(LogHandle);
}

void LogError()
{
  if (!EnableLogging) return;
  if (LogHandle <= 0) return;

  string msg="Error:"+ GetLastError()+" OrderType:"+OrderType()+" Ticket:"+OrderTicket();
  msg = TimeToStr(TimeCurrent(),
      TIME_DATE | TIME_MINUTES | TIME_SECONDS) + " " + msg;
  FileWrite(LogHandle, msg);
}
//End Of File